/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/litmuschaos/chaos-operator/api/litmuschaos/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeChaosEngines implements ChaosEngineInterface
type FakeChaosEngines struct {
	Fake *FakeLitmuschaosV1alpha1
	ns   string
}

var chaosenginesResource = schema.GroupVersionResource{Group: "litmuschaos.io", Version: "v1alpha1", Resource: "chaosengines"}

var chaosenginesKind = schema.GroupVersionKind{Group: "litmuschaos.io", Version: "v1alpha1", Kind: "ChaosEngine"}

// Get takes name of the chaosEngine, and returns the corresponding chaosEngine object, and an error if there is any.
func (c *FakeChaosEngines) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ChaosEngine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(chaosenginesResource, c.ns, name), &v1alpha1.ChaosEngine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ChaosEngine), err
}

// List takes label and field selectors, and returns the list of ChaosEngines that match those selectors.
func (c *FakeChaosEngines) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ChaosEngineList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(chaosenginesResource, chaosenginesKind, c.ns, opts), &v1alpha1.ChaosEngineList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.ChaosEngineList{ListMeta: obj.(*v1alpha1.ChaosEngineList).ListMeta}
	for _, item := range obj.(*v1alpha1.ChaosEngineList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested chaosEngines.
func (c *FakeChaosEngines) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(chaosenginesResource, c.ns, opts))

}

// Create takes the representation of a chaosEngine and creates it.  Returns the server's representation of the chaosEngine, and an error, if there is any.
func (c *FakeChaosEngines) Create(ctx context.Context, chaosEngine *v1alpha1.ChaosEngine, opts v1.CreateOptions) (result *v1alpha1.ChaosEngine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(chaosenginesResource, c.ns, chaosEngine), &v1alpha1.ChaosEngine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ChaosEngine), err
}

// Update takes the representation of a chaosEngine and updates it. Returns the server's representation of the chaosEngine, and an error, if there is any.
func (c *FakeChaosEngines) Update(ctx context.Context, chaosEngine *v1alpha1.ChaosEngine, opts v1.UpdateOptions) (result *v1alpha1.ChaosEngine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(chaosenginesResource, c.ns, chaosEngine), &v1alpha1.ChaosEngine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ChaosEngine), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeChaosEngines) UpdateStatus(ctx context.Context, chaosEngine *v1alpha1.ChaosEngine, opts v1.UpdateOptions) (*v1alpha1.ChaosEngine, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(chaosenginesResource, "status", c.ns, chaosEngine), &v1alpha1.ChaosEngine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ChaosEngine), err
}

// Delete takes name of the chaosEngine and deletes it. Returns an error if one occurs.
func (c *FakeChaosEngines) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(chaosenginesResource, c.ns, name), &v1alpha1.ChaosEngine{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeChaosEngines) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(chaosenginesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.ChaosEngineList{})
	return err
}

// Patch applies the patch and returns the patched chaosEngine.
func (c *FakeChaosEngines) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ChaosEngine, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(chaosenginesResource, c.ns, name, pt, data, subresources...), &v1alpha1.ChaosEngine{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ChaosEngine), err
}
