/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	litmuschaosv1alpha1 "github.com/litmuschaos/chaos-operator/api/litmuschaos/v1alpha1"
	versioned "github.com/litmuschaos/chaos-operator/pkg/client/clientset/versioned"
	internalinterfaces "github.com/litmuschaos/chaos-operator/pkg/client/informers/externalversions/internalinterfaces"
	v1alpha1 "github.com/litmuschaos/chaos-operator/pkg/client/listers/litmuschaos/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// ChaosEngineInformer provides access to a shared informer and lister for
// ChaosEngines.
type ChaosEngineInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.ChaosEngineLister
}

type chaosEngineInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewChaosEngineInformer constructs a new informer for ChaosEngine type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewChaosEngineInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredChaosEngineInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredChaosEngineInformer constructs a new informer for ChaosEngine type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredChaosEngineInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.LitmuschaosV1alpha1().ChaosEngines(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.LitmuschaosV1alpha1().ChaosEngines(namespace).Watch(context.TODO(), options)
			},
		},
		&litmuschaosv1alpha1.ChaosEngine{},
		resyncPeriod,
		indexers,
	)
}

func (f *chaosEngineInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredChaosEngineInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *chaosEngineInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&litmuschaosv1alpha1.ChaosEngine{}, f.defaultInformer)
}

func (f *chaosEngineInformer) Lister() v1alpha1.ChaosEngineLister {
	return v1alpha1.NewChaosEngineLister(f.Informer().GetIndexer())
}
