/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	litmuschaosv1alpha1 "github.com/litmuschaos/chaos-operator/api/litmuschaos/v1alpha1"
	versioned "github.com/litmuschaos/chaos-operator/pkg/client/clientset/versioned"
	internalinterfaces "github.com/litmuschaos/chaos-operator/pkg/client/informers/externalversions/internalinterfaces"
	v1alpha1 "github.com/litmuschaos/chaos-operator/pkg/client/listers/litmuschaos/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// ChaosExperimentInformer provides access to a shared informer and lister for
// ChaosExperiments.
type ChaosExperimentInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.ChaosExperimentLister
}

type chaosExperimentInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewChaosExperimentInformer constructs a new informer for ChaosExperiment type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewChaosExperimentInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredChaosExperimentInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredChaosExperimentInformer constructs a new informer for ChaosExperiment type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredChaosExperimentInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.LitmuschaosV1alpha1().ChaosExperiments(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.LitmuschaosV1alpha1().ChaosExperiments(namespace).Watch(context.TODO(), options)
			},
		},
		&litmuschaosv1alpha1.ChaosExperiment{},
		resyncPeriod,
		indexers,
	)
}

func (f *chaosExperimentInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredChaosExperimentInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *chaosExperimentInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&litmuschaosv1alpha1.ChaosExperiment{}, f.defaultInformer)
}

func (f *chaosExperimentInformer) Lister() v1alpha1.ChaosExperimentLister {
	return v1alpha1.NewChaosExperimentLister(f.Informer().GetIndexer())
}
